library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity set_DAC16 is
port (clk : in std_logic; 
 	dabeg : in std_logic; 
 	dabusy : out std_logic; 
 	dadata : in std_logic_vector(15 downto 0); 
	DAC_cs				: out  std_logic;
	DAC_clk				: out  std_logic;
	DAC_dout				: out  std_logic
 		); 
end set_DAC16;

architecture Behavioral of set_DAC16 is
	signal dbeg, ddbeg, dton, cswait, dacs : STD_LOGIC;
	signal dbuf : STD_LOGIC_VECTOR(15 downto 0);
	signal wordct : STD_LOGIC_VECTOR(3 downto 0);
	signal ckct : STD_LOGIC_VECTOR(1 downto 0);
begin
dabusy <= dton;
DAC_clk <= ckct(1);
DAC_cs <= dacs;	--DAC IC on/off

process (clk) 
begin
if clk='1' and clk'event then
	dbeg<=dabeg;	ddbeg<=dbeg;
	if dton='0' and dacs='1' and dbeg='1' and ddbeg='0' then	--check header
		dton <= '1';
		cswait <= '1';
		dacs <= '0';	--DAC IC on
		dbuf <= dadata;
		wordct <= (others=>'0');
	elsif cswait='1' then
		cswait <= '0';	-- +20ns
	elsif dton='1' then
		ckct <= ckct+1;
		if ckct="00" then
			DAC_dout  <= dbuf(15);
			dbuf(15 downto 1) <= dbuf(14 downto 0);
		elsif ckct="11" then
			wordct <= wordct+1;
			if wordct="1111" then	--end at 15 loop
				dton <= '0';
			end if;
		end if;
	else
		ckct <= (others=>'0');	--DAC_ck<='0';
		dacs <= '1';	--ADC IC off
		DAC_dout  <= '0';
	end if;
end if;
end process;

end Behavioral;
